<?php
/*
    Php class wich permit you to parse xml files in an array easily
    Copyright (C) 2010  Charles-Alban Allard
	Website: http://www.labo-caa.fr/
	VERSION: 1.1

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

define("XML_ANALYSER", 1.1);

class xmlAnalyser {
	private $xml ="";
	private $params = array();
	
	function __construct($xml){
		$this->xml = $xml;
	}
	
	function xmlToArray(){

		$xml_parser = xml_parser_create();

		xml_parse_into_struct($xml_parser, $this->xml, $vals, $index);
		xml_parser_free($xml_parser);
		$fichier_xml=array();
		$params = array();
		$level = array();

		//piles permettant de définir le path
		$tag_stack = array();
		$id_stack = array();
		foreach ($vals as $xml_elem) {

			//construction du path
			$path='$fichier_xml';
			foreach($tag_stack as $id=>$tag){
				$path.="['".$id_stack[$id]."']['child']";
			}
			//on récupère l'id du noeud suivant
			$cmd = 'if (isset(' . $path . ')){';
			$cmd .= '$next_node_id=count(' . $path . ');';
			$cmd .= '}else{';
			$cmd .= '$next_node_id=0;';
			$cmd .= '}';
			eval($cmd);
			if($path!='$fichier_xml'){
				$next_node_id=$next_node_id;
			}

			//balise ouvrante
			if ($xml_elem['type'] == 'open') {
				$path .= '[' . $next_node_id . ']';
				
				// si il y des attributs il faut les ajouter
					eval($path . '["type"]=$xml_elem["tag"];');
					
					$cmd = 'if (isset($xml_elem["attributes"])){';
					$cmd .= $path . '["attributes"]=$xml_elem["attributes"];';
					$cmd .= '}else{';
					$cmd .= $path . '["attributes"]=null;';
					$cmd .= '}';
					eval($cmd);
					
					$cmd = 'if (isset($xml_elem["value"])){';
					$cmd .= $path . '["value"]=$xml_elem["value"];';
					$cmd .= '}else{';
					$cmd .= $path . '["value"]=null;';
					$cmd .= '}';
					eval($cmd);
				
				//ajout des informations dans la pile
				
				array_push($tag_stack, $xml_elem['tag']);
				array_push($id_stack, $next_node_id);
				
				
			} elseif (($xml_elem['type'] == 'complete')) {
			

				$path .= '[' . $next_node_id . ']';

				//ajout des informations dans la pile
				eval($path . '["type"]=$xml_elem["tag"];');
				
				$cmd = 'if (isset($xml_elem["attributes"])){';
				$cmd .= $path . '["attributes"]=$xml_elem["attributes"];';
				$cmd .= '}else{';
				$cmd .= $path . '["attributes"]=null;';
				$cmd .= '}';
				eval($cmd);
				
				$cmd = 'if (isset($xml_elem["value"])){';
				$cmd .= $path . '["value"]=$xml_elem["value"];';
				$cmd .= '}else{';
				$cmd .= $path . '["value"]=null;';
				$cmd .= '}';
				eval($cmd);
				
			}
			//balise fermante
			elseif ($xml_elem['type'] == 'close') {
				array_pop($tag_stack);
				array_pop($id_stack);
			}
		}
		
		return $fichier_xml;
	}
}
?>